.386
.model flat,stdcall
option casemap:none

include c:\masm32\include\windows.inc
include c:\masm32\include\user32.inc
include c:\masm32\include\kernel32.inc
include c:\masm32\include\advapi32.inc

includelib c:\masm32\lib\kernel32.lib
includelib c:\masm32\lib\user32.lib
includelib c:\masm32\lib\advapi32.lib

; ## LOCAL PROTOTYPES ###################################################

    IsWinNT         PROTO
    ReqNTPrivilege  PROTO :DWORD


; ## LOCAL MACROS ########################################################

    ; ---------------------
    ; literal string MACRO
    ; ---------------------
    literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
    ENDM
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
    SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
    ENDM

; ########################################################################

.const

    dwMaskNT    DWORD   2
    
; ########################################################################

.data

    AppName     BYTE "ASM Win NT ReBoot Demo",0
    msg_Task    BYTE "This demo will restart NT systems.",0
    msg_NotNT   BYTE "This is NOT an NT system.",0
    msg_NotPL   BYTE "Privilege requested NOT granted.",13,"Unable to reboot.",0

; ########################################################################

.data?

; ########################################################################

.code
start:

    invoke      IsWinNT

    ;----------------------------------------------------------------
    ; if is not an NT system we don't need other stuff and we can 
    ; directly call ExitWindowsEx(), so this demo will exit.
    ;----------------------------------------------------------------
    .if eax == FALSE        
        invoke      MessageBox,NULL,addr msg_NotNT,addr AppName,MB_OK

        invoke      ExitProcess,NULL
    .endif

    invoke      MessageBox,NULL,addr msg_Task,addr AppName,MB_OK


    ;----------------------------------------------------------------
    ; with ReqNTPrivilege call, we ask for the 'SeShutdownPrivilege'
    ; note string names of possible privilege are in windows.inc
    ;----------------------------------------------------------------
    invoke      ReqNTPrivilege, SADD("SeShutdownPrivilege")
    
    .if eax == FALSE

        invoke      MessageBox,NULL,addr msg_NotPL,addr AppName,MB_OK
        invoke      ExitProcess,NULL
    .endif

    invoke      ExitWindowsEx, EWX_REBOOT, 0
        
    invoke      ExitProcess,NULL
        
; ########################################################################

IsWinNT proc 

    ; return TRUE (not zero) in eax if we are in win nt systems
    
    LOCAL osvi:OSVERSIONINFO

    mov     osvi.dwOSVersionInfoSize, sizeof osvi

    invoke  GetVersionEx, addr osvi

    .if eax == 0
        ret
    .endif
    
    mov     eax, osvi.dwPlatformId

    and     eax, dwMaskNT
    
    ret

IsWinNT endp

; ######################################################################## 

ReqNTPrivilege proc lpPrivilegeName:DWORD

    ; return TRUE (not zero) in eax if privilege is granted
    ; lpPrivilegeName parameter points to a string with request privilege name

    LOCAL   hProcess    :DWORD
    LOCAL   hToken      :DWORD
    LOCAL   phToken     :DWORD
    LOCAL   RetLen      :DWORD
    LOCAL   pRetLen     :DWORD
    LOCAL   tkp         :TOKEN_PRIVILEGES
    LOCAL   tkp_old     :TOKEN_PRIVILEGES

    invoke  GetCurrentProcess
    mov     hProcess, eax

    lea     eax, hToken
    mov     phToken, eax
    
    invoke  OpenProcessToken, hProcess, \
                              TOKEN_ADJUST_PRIVILEGES Or TOKEN_QUERY, \
                              phToken  

    .if eax != FALSE

        lea     eax, tkp.Privileges[0].Luid
        invoke  LookupPrivilegeValue, NULL, \
                                      lpPrivilegeName, \
                                      eax

        lea     eax, RetLen
        mov     pRetLen, eax

        mov     tkp.PrivilegeCount, 1
        mov     tkp.Privileges[0].Attributes, SE_PRIVILEGE_ENABLED
        
        invoke  AdjustTokenPrivileges, hToken, \
                                       NULL, \
                                       addr tkp, \
                                       sizeof tkp_old, \
                                       addr tkp_old, \

                                       pRetLen
        
        
    .endif
    
    ret
    
ReqNTPrivilege endp

; ######################################################################## 

end start

